--- a/x2goserver/bin/x2gostartagent
+++ b/x2goserver/bin/x2gostartagent
@@ -24,14 +24,23 @@
 
 $X2GO_LIB_PATH/x2gosyslog "$0" "info" "$(basename $0) called with options: $@"
 
-X2GO_PORT=49 #First port for X2GO=50
-SSH_PORT=30000 #First ssh port 30001
+X2GO_AGENT_OPTIONS_PATH="/etc/x2go/x2goagent.options"
 
 X2GO_ROOT="${HOME}/.x2go"
 export NX_ROOT=$X2GO_ROOT
 
-if [ -r /etc/x2go/x2goagent.options ]; then
-    source /etc/x2go/x2goagent.options
+if [ -r $X2GO_AGENT_OPTIONS_PATH ]; then
+    source $X2GO_AGENT_OPTIONS_PATH
+fi
+
+if [ -z "$X2GO_PORT" ]; then
+    # Use ports 30000-30099 [30000 (base) + 79 (random) + 10 (x2go) + 10 (ssh)]
+    X2GO_PORT_BASE=$RANDOM
+    let "X2GO_PORT_BASE %= 79"
+    let "X2GO_PORT = X2GO_PORT_BASE + 30000" # First port for X2GO
+    let "SSH_PORT = X2GO_PORT_BASE + 30010" # First port for SSH
+    echo "X2GO_PORT=$X2GO_PORT" >> $X2GO_AGENT_OPTIONS_PATH
+    echo "SSH_PORT=$SSH_PORT" >> $X2GO_AGENT_OPTIONS_PATH
 fi
 
 if [ -z "$X2GO_NXAGENT_OPTIONS" ]; then
